﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Threading;

namespace Thread5
{
    public partial class Form1 : Form
    {
        Thread _t1, _t2;

        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            LHabeFertig.Text = "";
            _t1 = null;
            _t2 = null;
        }


         // stur nacheinander
        private void BnStart1_Click(object sender, EventArgs e)
        {
            Editor1.Text = "";
            Editor2.Text = "";
            for (int i = 0; i < 1000; i++)
            {
                Editor1.Text = Editor1.Text + i.ToString() + "\r\n";
            }
            for (int i = 0; i < 1000; i++)
            {
                Editor2.Text = Editor2.Text + i.ToString() + "\r\n";
            }

        }


        // Hier Absturz
        delegate void SetTextCallback(string text);

        private void SetText1a(string text)
        {
           this.Editor1.Text = text;
        }
        private void SetText2a(string text)
        {
           this.Editor2.Text = text;
        }


        public void run1()
        {
            Editor1.Text = "";
            for (int i = 0; i < 100; i++)
            {
                string sStr = i.ToString() + "\r\n" + Editor1.Text;
                SetText1a(sStr);
                Thread.Sleep(50);
            }
        }
        public void run2()
        {
            Editor1.Text = "";
            for (int i = 0; i < 100; i++)
            {
                string sStr = i.ToString() + "\r\n" + Editor2.Text;
                SetText2a(sStr);
                Thread.Sleep(50);
            }
        }

        private void BnStart2_Click(object sender, EventArgs e)
        {
            ThreadStart ts1, ts2;
            ts1 = new ThreadStart(run1);
            ts2 = new ThreadStart(run2);

            Thread t1, t2;
            t1 = new Thread(ts1);
            t2 = new Thread(ts2);
            t1.Start();
            t2.Start();
            LHabeFertig.Text = "Fertig";
        }


        // 333333333333333333333333333333333333333333333333333
        private void SetText1b(string text)
        {
            // Wenn das GUI-Element von einem anderem Thread belegt ist
            // muss das "Setzen" in eine Warteschlange eingefügt werden
            if (this.Editor1.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText1b);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.Editor1.Text = text;
            }
        }
        private void SetText2b(string text)
        {
            // Wenn das GUI-Element von einem anderem Thread belegt ist
            // muss das "Setzen" in eine Warteschlange eingefügt werden
            if (this.Editor2.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText2b);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.Editor2.Text = text;
            }
        }

        public void run3()
        {
            Editor1.Text = "";
            for (int i = 0; i < 100; i++)
            {
                string sStr = i.ToString() + "\r\n" + Editor1.Text;
                SetText1b(sStr);
                Thread.Sleep(50);
            }
        }

       public void run4()
        {
            Editor2.Text = "";
            for (int i = 0; i < 100; i++)
            {
                string sStr = i.ToString() + "\r\n" + Editor2.Text;
                SetText2b(sStr);
                Thread.Sleep(100);
            }
        }

        private void BnStart3_Click(object sender, EventArgs e)
        {
            ThreadStart ts1, ts2;
            ts1 = new ThreadStart(run3);
            ts2 = new ThreadStart(run4);

            _t1 = new Thread(ts1);
            _t2 = new Thread(ts2);
            _t1.Start();
            _t2.Start();
            LHabeFertig.Text = "Fertig";
        }

        
        /*
           The FormClosing event occurs as the form is being closed. 
           When a form is closed, it is disposed, releasing all resources associated with the form. 
           If you cancel this event, the form remains opened. 
           To cancel the closure of a form, set the Cancel property of the FormClosingEventArgs 
           passed to your event handler to true. 

        */
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // sind die Threads beendet ?
            if ( (_t1 != null) && (_t1.IsAlive) )
            {
                e.Cancel = true;
                return;
            }
            if ((_t2 != null) && (_t2.IsAlive))
            {
                e.Cancel = true;
                return;
            }
            e.Cancel = false;
        }

        private void Form1_FormClosing_Alternative(object sender, FormClosingEventArgs e)
        {
            // nun die Threads beenden
            if (_t1.IsAlive)
            {
                _t1.Abort();
            }
            if (_t2.IsAlive)
            {
                _t2.Abort();
            }
            e.Cancel = false;
        }
    }
}
